/*
 * main.c
 *
 *  Created on: Jan 26, 2015
 *      Author: skai
 */

#include <hpgcc3.h>
// #include <hpgraphics.h>

// ARMCODE_CONFIG_STACK_STANDARD
// TO KEEP THE KEYBOARD AND TIMERS ENABLED, USE INSTEAD:
// ARMCODE_CONFIG(_STACK_SPEED_120MHZ);
ARMCODE_CONFIG(startup)= /*_NO_SCREEN  |  _NO_WAITKEY |_NO_KEYBOARD| */ _SPEED_120MHZ;
ARMCODE_CONFIG(memory_req)=USE_MAINRAM|USE_ERAM|USE_KOSRAM|RESERVE_TEMPOB(16)|RESERVE_USEROB(16);

//int forced_to_matrix=0;
//int push_as_vector=0;
//int debug=1;
//int  mode;
//int hpdigits;

#include "main.h"




int main(){
    int n;
    double *vector=NULL;
    sat3_cknerror(2);								// require two inputs on stack
    sat3_checkargserror(2,SAT_DOARRY, SAT_DOCSTR);	// 2: vector 1:realflag
   vector=sat_create_pop_double_vector(&n);

  	chebsamplemain( vector,n); // pop function in list-string format, sample and cheb transform
  	sat_push_double_vector_0(n,vector);
	free(vector);
	return 0;
}



