///*
// * parrom.c
// *
// *  Created on: May 7, 2014
// *      Author: skai
// */
//
//#include "parrom.h"
//
//
//
////#define _SQRT						"\x83"
//// HP50g character 131   square root
//// #define PI_							"\x87"
//// #define SYSFLAG                      0x80F02
//// #define	RAD_FLAG					17
//// #define FIX_ENG_FLAG				49
//// #define SCI_ENG_FLAG				50
//// hpdigits are   flag 45-6-7-8
//// #define HPDIGITS_FLAG				45
//// #define HPSYSFLAG_COMMA_MODE		51
//// #define HPSYSFLAG_TINY_ELEMENT		54
//
//// #define NULL 						0
//// #define DEG_TO_RAD(ang) 			((ang) * PI / 180.0)
//// #define EPSILON_E50					(double) (1E-50)
//// #define EPSILON_E5 					(double) (1E-5)
//// #define EPSILON_E3 					(double) (1E-3)
//
//// #define pi                          PI
//
//
//#define NUMBER_TYPE				0
//#define FUNCTION_TYPE			1
//#define VARIABLE_TYPE			2
//#define RANGE_TYPE				3
//#define OPERATOR_TYPE			4
//
//#define PARSE_EQUATIONS			1
//// #define FX					0
//// #define FY					1
//#define FZ						0
//
//#define X_DIM					0
//#define Y_DIM					1
//
//#define	A						0
//#define	B						1
//#define	C						2
//#define	D						3
//
//
//// hpg_t *hpg_stdscreen;
//// Error messages used by parser for automatic errorhandling on calculator
//#define INVALID_SYNTAX     		262
//#define	INVALID_USERFUNCTION   	259		// undefined function , or name not A,B,C,D
//#define NOT_ENOUGH_ARM_MEMORY	 43    // buffer overflow, increase MAX_TOKEN and recompile
//
//double convert_angle(double r);  //{ 1.0, PI / 180.0 , PI / 200.0  };
//double convert_angle_back(double r); //[3]{ 1.0 , 180.0 / PI , 200.0 / PI };
//
//
//double addition(), subtraction();
//double multiplication(), division();
//double sindeg(), cosdeg(), tandeg(), asindeg(), acosdeg(), atandeg();
//double sinhp(), coshp(), tanhp();
//double neg(), inv(),realsqrt();
//double sq();
//double exp_10();
//double fact();
//double piconstant();
//// double simplex(double (*func)(double[]), double start[],int n_dims, double EPSILON, double scale);
//
//double atof_local(const char * _buf);
//int stack_index;
//char function_name[NAME_LENGTH];
//double execution_stack[STACK_DEPTH];
//int Ivar=0;
//FUNCTION function[MAX_FUNCTION] = {
//    {_SQRT, 1, realsqrt},   // +1
//	{"SIN", 1, sindeg},    //
//	{"COS", 1, cosdeg},
//	{"TAN", 1, tandeg},
//	{"SINH", 1, sinhp},
//
//	{"COSH", 1, coshp},
//	{"TANH", 1, tanhp},
//	{"ASIN", 1, asindeg},
//	{"ACOS", 1, acosdeg},
//	{"ATAN", 1, atandeg},
//
//	{"LN", 1, log},
//	{"LOG", 1, log10},
//	{"NEG", 1, neg},
//	{"INV", 1, inv},
//	{"ABS", 1, fabs},
//
//	{"EXP", 1, exp},
//	{"SQ", 1, sq},
//	{"ALOG", 1, exp_10},
//	{"!", 1, fact},
//	{"^", 2, pow},
//
//	{"+", 2, addition},
//	{"-", 2, subtraction},
//	{"*", 2, multiplication},
//	{"/", 2, division},
//	{PI_, 0, piconstant},
//};
//
////																								constants, macros, prototypes
//
//int get_equation() {
////	sat3_ckn(1);  // sat3_exiterror();
////	sat3_checkargserror(1, SAT_DOCSTR);
//	equation.expression = sat3_pop_string_alloc();
//	if(parse_expression() == NULL ) return 0;
////	if(	(equation.xyz_expression[FZ] = sat3_pop_string_alloc()) == NULL )
////			{ printf("Error: expression missing\n"); keyb_getkey(1); return 0;}
////	if(parse_expression(FZ) == NULL ) return 0;
//// 	get_parameters();
////	if(parameters.scale <= 0.0) parameters.scale = 1.;
////	if(parameters.epsilon <=0.0) parameters.epsilon=1.0e-4;
////	int i0=variable.value[COUNTER1_START];
////	int i1=variable.value[COUNTER1_STOP];
////	if (i0<=i1){if (variable.value[COUNTER1_STEP]<=0) variable.value[COUNTER1_STEP]=1;}
////	if (i0>=i1){if (variable.value[COUNTER1_STEP]>=0) variable.value[COUNTER1_STEP]=-1;}
//	return 1;
//}
//
//int parse_expression(int xyz_index) {
////	SAT_OBJECT sat_obj;
//	int found = 0;
//	double r;
//	stack_index=4; // scratch for simple optimalization
//
//	char *expression = equation.expression;
//
//	if(*expression != '{' || expression[strlen(expression) - 1] != '}')
//		sat3_exiterror(INVALID_SYNTAX); // { printf("Error: not a valid expression\n"); keyb_getkey(1); return 0;}
//	expression += 2; equation.tokennumber = 0;
//
//	while(*expression != '}') {
//
//		if(equation.tokennumber >= MAX_TOKEN)
//			sat3_exiterror(NOT_ENOUGH_ARM_MEMORY); //{printf("Error: expression too long\n"); keyb_getkey(1); return 0;}
//
//		if( isnumber(*expression) || ( *expression == '-' &&  isnumber(* (expression + 1)))) {
//			equation.token[equation.tokennumber].value = atof_local(expression);
//			equation.token[equation.tokennumber++].type = NUMBER_TYPE;
//			while(*expression != ' ') ++expression; ++expression;
//		}
//
//		else if( isvariable(*expression) && *(expression + 1) == ' ') {
//			int index = *expression - 'a';
//			r=variable.value[index];
//			equation.token[equation.tokennumber].value = r;
//			equation.token[equation.tokennumber++].type = NUMBER_TYPE;
////			equation.token[equation.tokennumber].index = index;
////			equation.token[equation.tokennumber++].type = VARIABLE_TYPE;
//			expression += 2;
//		}
//
//		else if( isrange(*expression) && *(expression + 1) == ' ') {
//			equation.token[equation.tokennumber].index = *expression - 'X'; // TODO: check if 'x'
//			equation.token[equation.tokennumber++].type = RANGE_TYPE;
//			expression += 2;
//		}
//
//		else if( isoperator((int) *expression) && *(expression + 1) == ' ') {
//			equation.token[equation.tokennumber].index = (int) *expression;
//			equation.token[equation.tokennumber++].type = OPERATOR_TYPE;
//			expression += 2;
//		}
//
//		else {
//			int i = 0;
//			while(*expression != ' ') function_name[i++] = *expression++;
//			function_name[i] = '\0'; ++expression;
////			sat_obj=sat3_rcl(function_name);
////			if (sat_obj){
////				equation.token[equation.tokennumber].value =sat3_convertreal_dbl(sat_obj);
////				equation.token[equation.tokennumber++].type = NUMBER_TYPE;
////				while(*expression != ' ') ++expression; ++expression;
////			}
////			else
////			{
//				found=0;
//			for(i = 0; i < MAX_FUNCTION; i++) {
//				if(!strcmp(function[i].name, function_name)) {
//					equation.token[equation.tokennumber].index = i;
//					equation.token[equation.tokennumber++].type = FUNCTION_TYPE;
//					found = 1; goto found_ok; break;
//					}
//				}
//
//			if(!found) {sat3_exiterror(INVALID_USERFUNCTION);}
//	//		}
//		found_ok:
//	// simple optimalisation, function constants and rationals
//				i=equation.token[equation.tokennumber-1].index;
//				execution_stack[stack_index]=equation.token[equation.tokennumber-2].value;
//				execution_stack[stack_index-1]=equation.token[equation.tokennumber-3].value;
//				if (
//					(function[i].argnum==0)
//					) {
//					r=function[i].function();
//					equation.token[equation.tokennumber-1].value=r;
//					equation.token[equation.tokennumber-1].type = NUMBER_TYPE; // skai
//				}
//				else if (
//					(function[i].argnum==1) &&
//					(equation.token[equation.tokennumber-2].type == NUMBER_TYPE)
//					) {
//					r=function[i].function(execution_stack[stack_index]);
//					equation.tokennumber--;
//					equation.token[equation.tokennumber-1].value=r;
//				}
//				else if (
//					(function[i].argnum==2) &&
//					(equation.token[equation.tokennumber-2].type == NUMBER_TYPE) &&
//					(equation.token[equation.tokennumber-3].type == NUMBER_TYPE)
//					) {
//					r=function[i].function(execution_stack[stack_index-1],execution_stack[stack_index]);
//					equation.tokennumber--;
//					equation.tokennumber--;
//					equation.token[equation.tokennumber-1].value=r;
//				}
//
//		}
//	}
//	return 1;
//}
//double compute_xyz( double Xvar, double Yvar) {
//	stack_index = -1;
////	int xyz_index=FZ;
//	int token;
//	for(token = 0; token < equation.tokennumber; token++) {
//		switch(equation.token[token].type) {
//			case NUMBER_TYPE:	execution_stack[++stack_index] = equation.token[token].value;
//								break;
//
//			case RANGE_TYPE:	if(equation.token[token].index == X_DIM)
//									execution_stack[++stack_index] = Xvar;
//								else if(equation.token[token].index == Y_DIM)
//										execution_stack[++stack_index] = Yvar;
//								else
//									execution_stack[++stack_index] = Ivar;
//								break;
//
//			case VARIABLE_TYPE:	execution_stack[++stack_index] = variable.value[equation.token[token].index];
//								break;
//
//			case OPERATOR_TYPE:	execution_stack[stack_index] = sqrt(execution_stack[stack_index]);
//								break;
//
//			case FUNCTION_TYPE:if(function[equation.token[token].index].argnum == 1)
//									execution_stack[stack_index] =
//										function[equation.token[token].index].function(execution_stack[stack_index]);
//								else {
//									execution_stack[stack_index - 1] =
//									function[equation.token[token].index].function(execution_stack[stack_index - 1],execution_stack[stack_index]);
//									--stack_index;
//								}
//								break;
//		}
//	}
//	return execution_stack[stack_index];
//}
//
//
///*
//float compute_xyz( float u, float v) {
//	stack_index = -1;
//	int xyz_index=FZ;
//	int token;
//	for(token = 0; token < equation.xyz_tokennumber[xyz_index]; token++) {
//		switch(equation.xyz_token[xyz_index][token].type) {
//			case NUMBER_TYPE:	execution_stack[++stack_index] = equation.xyz_token[xyz_index][token].value;
//								break;
//
//			case RANGE_TYPE:	if(equation.xyz_token[xyz_index][token].index == X_DIM)
//									execution_stack[++stack_index] = u;
//								else
//									execution_stack[++stack_index] = v;
//								break;
//
//			case VARIABLE_TYPE:	execution_stack[++stack_index] = variable.value[equation.xyz_token[xyz_index][token].index];
//								break;
//
//			case OPERATOR_TYPE:	execution_stack[stack_index] = sqrt(execution_stack[stack_index]);
//								break;
//
//			case FUNCTION_TYPE:if(function[equation.xyz_token[xyz_index][token].index].argnum == 1)
//									execution_stack[stack_index] =
//										function[equation.xyz_token[xyz_index][token].index].function(execution_stack[stack_index]);
//								else {
//									execution_stack[stack_index - 1] =
//									function[equation.xyz_token[xyz_index][token].index].function(execution_stack[stack_index - 1],execution_stack[stack_index]);
//									--stack_index;
//								}
//								break;
//		}
//	}
//	return execution_stack[stack_index];
//}
//*/
////																							math functions
//double addition() {return execution_stack[stack_index - 1] + execution_stack[stack_index];};
//double subtraction() {return execution_stack[stack_index - 1] - execution_stack[stack_index];};
//double multiplication() {return execution_stack[stack_index - 1] * execution_stack[stack_index];};
//double division() {
//	if(execution_stack[stack_index] == 0.0) execution_stack[stack_index] = EPSILON_E50;
//	return execution_stack[stack_index - 1] / execution_stack[stack_index];
//}
//double neg(){return -execution_stack[stack_index];}
//double inv(){if(execution_stack[stack_index] == 0.0) execution_stack[stack_index] = EPSILON_E50;return 1.0 / execution_stack[stack_index];}
//double realsqrt(){ return (execution_stack[stack_index]>=0.0) ? sqrt(execution_stack[stack_index]): (sat3_exiterror(SATERR_BADARGVALUE), 0.0);}
//double sq() { return execution_stack[stack_index] * execution_stack[stack_index];};
//double sindeg(){ return sin(convert_angle(execution_stack[stack_index]));}
//double cosdeg(){ return cos(convert_angle(execution_stack[stack_index]));}
//double tandeg(){ return tan(convert_angle(execution_stack[stack_index]));}
//double asindeg(){ return (execution_stack[stack_index]>=-1.0&&execution_stack[stack_index]<= 1.0)
//				? convert_angle_back(asin(execution_stack[stack_index])) : (  sat3_exiterror(SATERR_BADARGVALUE), 0.0);}
//double acosdeg(){ return (execution_stack[stack_index]>=-1.0&&execution_stack[stack_index]<= 1.0)
//		? convert_angle_back(acos(execution_stack[stack_index])) : (  sat3_exiterror(SATERR_BADARGVALUE), 0.0);}
//double atandeg(){ return convert_angle_back(atan(execution_stack[stack_index]));}
//double sinhp(){return (exp(execution_stack[stack_index]) - exp(-execution_stack[stack_index])) * 0.5;}
//double coshp(){return (exp(execution_stack[stack_index]) + exp(-execution_stack[stack_index])) * 0.5;}
//double tanhp(){double q; if( (q = coshp()) == 0.0) q = EPSILON_E5; return (sinhp() / q);}
//double exp_10(){ return (exp(LOG10*execution_stack[stack_index]));}
//double fact(){ int i,i2; double rfact=1; i2=execution_stack[stack_index]; for (i=1; i<=i2;i++)rfact*=i; return (rfact);}
//double piconstant() {return ( PI );}
//
